<template>
  <div v-if="top_pick">
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div
      class="blogger_name"
      v-if="GETTER_DATA_BLOGGER_NAME_ENABLE"
      contenteditable="true"
      @input="blogName"
      debounce="1000"
    >
      {{ top_pick.blogger_name ? nameBlogger : "BLOGGER NAME" }}
    </div>
    <drag :data="index">
      <drop @drop="outside" @click="chooseTopPickById">
        <div v-if="top_pick" style="vertical-align: top">
          <div class="blogger">
            <div
              class="hero_img"
              style="position: relative"
              @click="chooseTopPickById"
            >
              <a
                :data-href="top_pick.share_url ? top_pick.share_url : '#'"
                target="_blank"
              >
                <div v-if="!nameBlogger">
                  <input
                    v-if="!inputSearch"
                    type="url"
                    v-model="inputSearch"
                    class="inputsearch"
                    style="color: transparent"
                    @change="onChangeInput"
                  />
                </div>
                <img
                  v-if="top_pick.hero_image"
                  :src="top_pick.hero_image"
                  style="width: 100%; margin: auto"
                  @dblclick="ShowCropImage"
                />
                <img
                  v-if="!top_pick.hero_image"
                  src="../assets/img/drop-here.png"
                  style="width: 100%; margin: auto"
                />
              </a>
            </div>

            <div class="thumb_imgs">
              <div
                :class="'thumb_img_' + GETTER_DATA_PRODUCT_OF_ROW"
                v-for="(item, idx) in top_pick.products.slice(
                  0,
                  GETTER_DATA_PRODUCT_OF_ROW
                )"
                :key="idx"
              >
                <a
                  :data-href="item.hyperlink ? item.hyperlink : '#'"
                  target="_blank"
                  style="width: 100%;float:left;display:block;line-height: 0 !important;"
                >
                  <img
                    v-if="item.image_url.length > 0"
                    :src="item.image_url"
                    @click="deleteImageProductById(item.image_url)"
                    style="width: 100%;  "
                  />
                  <img
                    v-else-if="item.image_url.length == 0"
                    src="../assets/img/xam.jpg"
                    style="width: 100%;"
                  />
                </a>
              </div>
            </div>
          </div>
        </div>
      </drop>
    </drag>
    <a
      :data-href="top_pick.share_url"
      target="_blank"
      style="margin-top:8px;display:block"
    >
      <div
        class="cta"
        v-if="GETTER_DATA_BLOGGER_CTA_ENABLE"
        contenteditable="true"
        @input="changeShop"
      >
        {{ shopTheLook ? shopTheLook : "SHOP THE LOOK" }}
      </div>
    </a>
    <div style="height: 50px" v-if="top_pick.id">
      <base-button
        class="btn btn-default clear"
        @click="deleteTopPickById"
        role="button"
        >Clear</base-button
      >
    </div>
  </div>
</template>

<script>
import { Drop, Drag } from "vue-easy-dnd";
import { mapGetters } from "vuex";
import { ModalBus } from "../eventBus";
import Alert from "@/components/Alert";
import ViewCropImage from "../components/ViewCropImage";
import _ from "lodash";

export default {
  props: ["top_pick", "index"],
  data() {
    return {
      blogger_name: "",
      id: null,
      inputSearch: null,
      isLoading: false,
      nameBlogger: null,
      shopTheLook: this.top_pick.shopthelook,
      showCrop: false
    };
  },
  watch: {
    // GETTER_DATA_TOP_PICK() {
    //   this.nameBlogger = this.top_pick.blogger_name;
    // },
    top_pick(newadata) {
      this.nameBlogger = this.top_pick.blogger_name;
      this.shopTheLook = this.top_pick.shopthelook;
      this.id = this.top_pick.id;
      if (this.top_pick.id == null) {
        this.inputSearch = null;
      }
    },
    nameBlogger() {
      this.nameBlogger = this.top_pick.blogger_name;
    }
  },
  mounted() {
    if (!this.nameBlogger) {
      this.nameBlogger = this.top_pick.blogger_name;
    }
  },
  updated() {
    this.nameBlogger = this.top_pick.blogger_name;
  },
  components: {
    Drop,
    Drag
  },
  computed: {
    ...mapGetters([
      "GETTER_DATA_TOP_PICK",
      "GETTER_DATA_SEARCH",
      "GETTER_DATA_PRODUCT_OF_ROW",
      "GETTER_DATA_BLOGGER_NAME_ENABLE",
      "GETTER_DATA_BLOGGER_CTA_ENABLE"
    ])
  },
  methods: {
    ShowCropImage() {
      let props = {
        text: this.top_pick.hero_image,
        infor_hero_image: this.top_pick.infor_hero_image,
        id: this.top_pick.id
      };
      ModalBus.$emit("open", {
        component: ViewCropImage,
        title: `Crop Image`,
        props
      });
    },

    blogName: _.debounce(function(e) {
      this.$store.dispatch("ACTION_CHANGE_NAME_TOP_PICK_BY_ID", {
        id: this.top_pick.id,
        blogger_name: e.target.innerText
      });
    }, 1000),

    changeShop(e) {
      if (this.top_pick.id) {
        this.$store.dispatch("ACTION_CHANGE_SHOP_THE_LOOK_TOP_PICK_BY_ID", {
          id: this.top_pick.id,
          shopthelook: e.target.innerText
        });
      }
    },
    async onChangeInput() {
      let input = this.inputSearch;
      let arrInput = input.split("?");
      let params = arrInput[0].split("/").pop();
      const props = {
        type: "",
        text: ""
      };
      this.isLoading = true;
      if (this.GETTER_DATA_TOP_PICK.filter(e => e.id === params).length === 1) {
        props.type = "warning";
        props.text = "This blogger is existed. Please choose another blogger.";
        ModalBus.$emit("open", {
          component: Alert,
          title: "Warning",
          mode: "fiftyPercent",
          props
        });
        this.inputSearch = null;
      } else {
        let checkDataSearchById = this.GETTER_DATA_SEARCH.filter(
          e => e.id === params
        );
        if (checkDataSearchById.length === 1) {
          this.$store.dispatch("ACTION_INSERT_TOP_PICK", {
            id: checkDataSearchById[0].id,
            hero_image: checkDataSearchById[0].hero_image,
            blogger_name: checkDataSearchById[0].blogger_name,
            blog_url: checkDataSearchById[0].blog_url,
            share_url: checkDataSearchById[0].share_url,
            infor_hero_image: checkDataSearchById[0].infor_hero_image,
            index: this.index,
            products: checkDataSearchById[0].products
          });
        } else {
          // ltk api version 1
          // let result = await this.$store.dispatch("LTKS_REQUEST", {
          //   params,
          //   index: this.index
          // });

          // ltk api version 2
          let result = await this.$store.dispatch("RS_REQUEST", {
            params,
            index: this.index
          });
          if (result == undefined) {
            this.inputSearch = null;
          }
        }
      }
      this.isLoading = false;
      this.nameBlogger = this.top_pick.blogger_name;
      this.shopTheLook = this.top_pick.shopthelook;
      this.id = this.top_pick.id;
    },
    outside(event) {
      if (event.data || event.data >= 0) {
        if (event.data >= 0) {
          this.$store.dispatch("ACTION_CHANGE_POSITION_TOP_PICK", {
            from: this.index,
            to: event.data
          });
        }
        if (
          this.GETTER_DATA_TOP_PICK.filter(e => e.id == event.data.id).length >
          0
        ) {
          // console.log("aaaa");
        } else {
          if (this.GETTER_DATA_TOP_PICK[this.index].id == null) {
            this.$store.dispatch("ACTION_INSERT_TOP_PICK", {
              id: event.data.id,
              hero_image: event.data.hero_image,
              blogger_name: event.data.blogger_name,
              index: this.index,
              blog_url: event.data.blog_url,
              share_url: event.data.share_url,
              infor_hero_image: event.data.infor_hero_image,
              products: event.data.products
            });
          }
        }
      }
    },

    deleteTopPickById() {
      this.$store.dispatch("ACTION_DELETE_TOP_PICK", {
        id: this.top_pick.id,
        index: this.index
      });
      this.inputSearch = null;
    },

    deleteImageProductById(image_url) {
      this.$store.dispatch("ACTION_DELETE_IMAGE_PRODUCT_TOP_PICK", {
        image_url,
        index: this.index,
        type: 1,
        blogger_name: this.blogger_name
      });
    },

    chooseTopPickById() {
      if (this.top_pick.blogger_name) {
        this.$store.dispatch("ACTION_CHOOSE_TOP_PICK_BY_ID", {
          id: this.top_pick.id
        });
        // this.inputSearch = null;
      }
    }
  }
};
</script>

<style scoped>
a,
a:hover {
  text-decoration: none;
}
.blogger {
  width: 100%;
  text-align: center;
}
.blogger_name {
  color: #000000 !important;
  display: block;
  font-family: Gotham, "Gill Sans", sans-serif;
  font-size: 14px;
  font-style: normal;
  font-weight: normal;
  line-height: 100%;
  letter-spacing: normal;
  margin-top: 35px;
  margin-right: 0;
  margin-bottom: 35px;
  margin-left: 0;
  text-align: center;
  letter-spacing: 1px;
  text-transform: uppercase;
}
.hero_img {
  /* background-color: #ccc;
  border: 0px dotted gray; */
  display: block;
  width: 100%;
  /* min-width: 150px;
  max-width: 200px; */
  /* min-height: 200px; */
  /* height: 150px; */
  /* margin: 2px; */
  margin: auto;
  text-align: center;
}

.hero_img img {
  /* max-width: 190px; */
}
.thumb_imgs {
  width: 100%;
  margin: auto;
  text-align: left;
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
}

.thumb_imgs_8,
.thumb_imgs_6 {
  width: 100%;
  min-height: 80px;
  margin: auto;
  text-align: left;
}

.thumb_imgs_3,
.thumb_imgs_4 {
  width: 100%;
  min-height: 40px;
  margin: auto;
  text-align: left;
}

.thumb_img_ {
  display: inline-block;
  background-color: #5787a4, 10%;
  border: 0px dotted gray;
  /* width: 20%; */
  /* width: 30px; */
  width: 25%;
  padding: 5px;
}

.thumb_img_8,
.thumb_img_4 {
  display: inline-block;
  background-color: #5787a4, 10%;
  border: 0px dotted gray;
  width: 25%;
  padding: 3px;
}

.thumb_img_6,
.thumb_img_3 {
  display: inline-block;
  background-color: #5787a4, 10%;
  border: 0px dotted gray;
  /* height: 30px; */
  width: 33%;
  padding: 5px 11px;
}

.thumb_imgs img {
  width: 25%;
  /* height: 30px; */
  display: inline-block;
}

.cta {
  margin-top: 12px;
  width: 100%;
  margin: auto;
  display: block;
  height: 42px;
  line-height: 42px;
  font-family: Didot, "Palatino Linotype", Palatino, serif;
  text-align: center;
  border: 1px solid #000000;
  font-size: 13px;
  background-color: #ffffff;
  color: #000000;
  font-style: italic;
  text-decoration: none;
}

.cta :hover {
  background-color: #000;
  color: #fff;
  text-decoration: none;
}

button.clear {
  width: 100%;
  margin-top: 8px;
  padding: 5px;
  color: #171717;
  background: #d7d7d7;
  border: 1px solid #c8c8c8;
}
input.inputsearch {
  position: absolute;
  width: 100%;
  border: 1px solid #ffffff00;
  left: 0px;
  height: 100%;
  background: none;
  outline: none;
}
</style>
